var boolShowApiErrors = false; // if true show alert messages else show error of API on console ;)
var strAPINotFound = "Management system interface not found.";
var strAPITooDeep = "Cannot find API - too deeply nested.";
var strAPIInitFailed = "Found API but LMSInitialize failed.";
var strAPISetError = "Trying to set value but API not available";
var numberSCO_ScoreMin = 0; // must be a number
var numberSCO_ScoreMax = 100; // must be a number > nSCO_Score_Min
var SCOFinishDone = false;
var SCOInitializeDone = false;
//var numberSCO_MasteryScore = 100;

//// API INTERFACE INITIALIZATION ////

var scormAPI = null;
//var dtmInitialized = new Date();
var boolSCOBrowseiePreviewforMoodle = false; // on scorm 1.2 this is if lesson_mode is browse, ok this in Moodle is preview mode


/*************************************/
//content definition
/*************************************/

var tests = //Code to replace with list of tests;


////////// Main SCORM Function ////////////

function FindAPI(win) {
	var numberFindAPITries = 0;
	while ((win.API == null) && (win.parent != null) && (win.parent != win)) {
		numberFindAPITries ++;
		if (numberFindAPITries > 500) {
			AlertUserOfAPIError(strAPITooDeep);
			return null;
		}
		win = win.parent;
	}
	return win.API;
}

function APIOK() {
	return ((typeof(scormAPI)!= "undefined") && (scormAPI != null))
}


function SCOInitialize() {
	var err = true;
	if (SCOInitializeDone){
		return err;
	}else{
		SCOInitializeDone = true;
	}
	
	if ((window.parent) && (window.parent != window)){
		scormAPI = FindAPI(window.parent)
	}
	if ((scormAPI == null) && (window.opener != null)) {
		scormAPI = FindAPI(window.opener)
	}
	if (!APIOK()) {
		AlertUserOfAPIError(strAPINotFound);
		err = false
	} else {
		err = scormAPI.LMSInitialize("");
		
		if (err == "true") {
			boolSCOBrowseiePreviewforMoodle = (scormAPI.LMSGetValue("cmi.core.lesson_mode") == "browse");
			if (!boolSCOBrowseiePreviewforMoodle) { // ie if is normal mode on Moodle, enter normally then all must be active ;)
				if (scormAPI.LMSGetValue("cmi.core.lesson_status") == "not attempted" || scormAPI.LMSGetValue("cmi.core.lesson_status") == "browsed") {
					err = SCOSetValue("cmi.core.lesson_status","incomplete");
					// When all the tests are completed, it is necessary to mark status as completed
					SCOSetValue("cmi.core.score.max",100);
					SCOSetValue("cmi.core.score.min",1);
					var numberOfTests = tests.length;
					var suspend_data = "cmi.objectives._count="+numberOfTests+","
					suspend_data += "cmi.objectives.completed=0,"
					for (var i = 0; i < numberOfTests; i++) {
						suspend_data += "cmi.objectives." + tests[i].idname + "=incomplete,";
					}
					SCOSetValue("cmi.suspend_data", suspend_data);
				}
				
				var bookmark = scormAPI.LMSGetValue("cmi.core.lesson_location");
				if (bookmark != "" && bookmark != window.location.href){
					window.location.href = bookmark;
				}
			}else{
				if (scormAPI.LMSGetValue("cmi.core.lesson_status") != "completed"){
					err = SCOSetValue("cmi.core.lesson_status","browsed");
				}
			}
		} else {
			AlertUserOfAPIError(strAPIInitFailed)
		}
	}	
	return err;
}

function SCOFinish() {
	var ok = false;
	if (APIOK() && !SCOFinishDone) {
		if (scormAPI.LMSGetValue("cmi.core.lesson_status") == "incomplete"){
			SCOSetValue("cmi.core.exit", "suspend");
		}
		scormAPI.LMSFinish("");
		SCOFinishDone = true;
	}
}


function SCOSetValue(element,value){
	// Special logic to manage some special values
	var err = "";
	if (!APIOK()){
		AlertUserOfAPIError(strAPISetError + ": " + element + ", " + value);
		err = "false"
	} else {
		err = scormAPI.LMSSetValue(element, value);
	}
	return err
}



////////// END Main SCORM Function ////////////

window.onload = SCOInitialize;
window.onunload = SCOFinish;
window.onbeforeunload = SCOFinish;


////////// Record page /////////
$('a').click( function(e) {
	SCOSetValue("cmi.core.lesson_location", this.href);
} );
//////// End Record page //////


///////// PUBLIC FUNCTION ////////////////
function SCOSetScore(idname, isTestPassed) {
	//General score logic
	var commit = "";
	if (APIOK()){
		// If user is brose the curse then do not set anything
		oldValue = SCOGetObjectiveData(idname);
		if (!boolSCOBrowseiePreviewforMoodle){//} && oldValue == "incomplete"){
			if (isTestPassed){
				commit = SCOSetObjectiveData(idname, "passed");
			}else{
				commit = SCOSetObjectiveData(idname, "failed");
			}
		}
	}else{
		AlertUserOfAPIError(strAPINotFound);
	}
	if (commit == "true"){
		//update general score (watch out is % of curse completed)
		var completed = parseInt(SCOGetObjectiveData("cmi.objectives.completed"));
		if (!isNaN(completed)){
			if (isTestPassed && (oldValue == "incomplete" || oldValue == "failed"))
				completed += 1;
			else if (!isTestPassed && (oldValue == "passed"))
				completed -= 1;
			SCOSetObjectiveData("cmi.objectives.completed",completed+"");
			var total = parseInt(SCOGetObjectiveData("cmi.objectives._count"));
			if (!isNaN(total)){
				var mainScore = ((completed*100)/total);
				SCOSetValue("cmi.core.score.raw",mainScore);
				if (mainScore == 100){
					SCOSetValue("cmi.core.lesson_status", "completed");
					SCOSetValue("cmi.core.exit", "");
				}
				scormAPI.LMSCommit("");
			}
		}
	}
}

function SCOObjetiveClosed(idname){
	SCOInitialize();
	if (APIOK()){
		var status = SCOGetObjectiveData(idname);
		if (status == "passed" || status == "failed" || boolSCOBrowseiePreviewforMoodle){
			return true;
		}
	}
	else{
		AlertUserOfAPIError(strAPINotFound);
	}
	return false;
}

function SCOasBrowse(){
	//will be replaced for now the function SCOObjetiveClosed by the this(SCOasBrowse)
	SCOInitialize();
	return APIOK() && boolSCOBrowseiePreviewforMoodle;
}
/////////END PUBLIC FUNCTION ///////////


//Objetive logic
function SCOSetObjectiveData(idname, value) {
	var result = "false";
	//var i = SCOGetObjectiveIndex(idname);
	var oldValue = "";
	if (APIOK()) {
		var suspend_data = scormAPI.LMSGetValue("cmi.suspend_data");
		oldValue = SCOGetObjectiveData(idname);
		suspend_data = suspend_data.replace(idname + "=" + oldValue, idname + "=" + value);
		SCOSetValue("cmi.suspend_data", suspend_data);
		//result = SCOSetValue("cmi.objectives." + i + "." + element, value);
		result = "true";
	}else{
		AlertUserOfAPIError(strAPINotFound);
	}
	return result;
}

function SCOGetObjectiveData(idname) {
	//var i = SCOGetObjectiveIndex(idname);
	//if (!isNaN(i)) {
	//	return scormAPI.LMSGetValue("cmi.objectives." + i + "." + element)
	//}
	var value = "";
	if (APIOK()) {
		var suspend_data = scormAPI.LMSGetValue("cmi.suspend_data");
		var partsOfStr = suspend_data.split(',');
		for (var i = 0; i < partsOfStr.length; i++) {
			if (partsOfStr[i].indexOf(idname) != -1){
				value = partsOfStr[i].split('=')[1];
				break;
			}
		}
	}else{
		AlertUserOfAPIError(strAPINotFound);
	}
	return value;
}
function AlertUserOfAPIError(strText) {
	if (boolShowApiErrors){
		alert(strText);
	}else{
		console.log(strText);
	}
}
/*
function SCOGetObjectiveIndex(idname){
	var i = -1;
	if (!APIOK()) {
		scormAPI.LMSInitialize("");
	}
	var nCount = parseInt(scormAPI.LMSGetValue("cmi.objectives._count"));
	if (!isNaN(nCount)) {
		for (i = nCount-1; i >= 0; i--){ //walk backward in case LMS does journaling
			if (scormAPI.LMSGetValue("cmi.objectives." + i + ".id") == idname) {
				return i
			}
		}
	}
	return i
}
*/